unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, PrntPrev, Buttons, StdCtrls, Gauges, ScrolCan;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PrevBtn: TSpeedButton;
    PrtBtn: TSpeedButton;
    SetupBtn: TSpeedButton;
    PrtDlgBtn: TSpeedButton;
    Desc: TLabel;
    PrintPreview1: TPrintPreview;
    Image1: TImage;
    procedure PrevBtnClick(Sender: TObject);
    procedure SetupBtnClick(Sender: TObject);
    procedure PrtDlgBtnClick(Sender: TObject);
    procedure PrintPreview1RenderPage(Page: Word; Canvas: TCanvas);
    procedure PrtBtnClick(Sender: TObject);
    procedure PrintPreview1ChkAbort(Page: Word);
    procedure PrintPreview1SelectionPages(Sender: TObject);
    procedure PrintPreview1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PrintPreview1PageStart(Page: Word);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.PrevBtnClick(Sender: TObject);
begin
  if PrintPreview1.Previewing then
  begin
    PrintPreview1.Previewing := False;
    PrevBtn.Caption := 'Preview';
  end
  else
  begin
    PrintPreview1.Previewing := True;
    PrevBtn.Caption := 'Close';
  end;
end;

procedure TForm1.SetupBtnClick(Sender: TObject);
begin
  PrintPreview1.SetupDlg;
end;

procedure TForm1.PrtDlgBtnClick(Sender: TObject);
begin
  PrintPreview1.PrintJobDlg;
end;

procedure TForm1.PrtBtnClick(Sender: TObject);
begin
  PrintPreview1.StartPrintJob('Test print job');
end;

procedure TForm1.PrintPreview1RenderPage(Page: Word; Canvas: TCanvas);
var
  Current: Integer;
  X, Y: Integer;
begin
  PrintPreview1.StretchDraw(Rect(0, -10000, 10000, -16000), Image1.Picture.Graphic);
  PrintPreview1.ChangeMapMode(mmAnisotropic, 1000, 1000);
  Canvas.Pen.Style := psSolid;
  Canvas.Pen.Width := 1;
  Canvas.Pen.Color := clBlack;
  Canvas.Brush.Style := bsClear;
  Canvas.Font.Name := 'Times New Roman';
  Canvas.Font.Height := 500;
  Canvas.Font.Color := clBlack;
  X := 500 - (Canvas.TextWidth(IntToStr(Page)) div 2);
  Y := 500 - (Canvas.TextHeight(IntToStr(Page)) div 2);
  Canvas.TextOut(X, Y, IntToStr(Page));
  PrintPreview1.SetClipArea(Rect(0, 400, 1000, 600));
  Canvas.Font.Color := clBlack;
  for Current := 0 to 100 do
  begin
    Canvas.Rectangle(500 + Current, 500 + Current, 500 + Current * 2, 500 + Current * 2);
  end;
  for Current := 100 to 200 do
  begin
    Canvas.Rectangle(500 + Current, 500 + Current, 500 + Current * 2, 500 + Current * 2);
  end;
  PrintPreview1.UnSetClipArea;
  for Current := 200 to 250 do
  begin
    Canvas.Rectangle(500 + Current, 500 + Current, 500 + Current * 2, 500 + Current * 2);
  end;
  Canvas.MoveTo(0,0);
  Canvas.LineTo(1000, 1000);
  Canvas.MoveTo(1000, 0);
  Canvas.LineTo(0, 1000);
  PrintPreview1.ChangeMapMode(mmText, 1000, 1000);
  Canvas.Font.Name := 'Times New Roman';
  Canvas.Font.Height := 100;
  Canvas.Font.Color := clBlack;
  Canvas.TextOut(0, 0, 'This is page ' + IntToStr(Page));
  Canvas.TextOut(0, 100, 'This second line is on page ' + IntToStr(Page));
  Canvas.TextOut(0, 200, 'The third line on page ' + IntToStr(Page) + ' is here');
  Canvas.TextOut(0, 300, 'This is page ' + IntToStr(Page) + ' line 4');

  PrintPreview1.ChangeMapMode(mmHiMetric, 1000, 1000);
  Canvas.Font.Name := 'Times New Roman';
  Canvas.Font.Height := PrintPreview1.PrintHiMet.Y div 2;
  Canvas.Font.Color := clBlack;
  X := (PrintPreview1.PrintHiMet.X - Canvas.TextWidth(IntToStr(Page))) div 2;
  Y := (PrintPreview1.PrintHiMet.Y - Canvas.TextHeight(IntToStr(Page))) div -2;
  Canvas.TextOut(X, Y, IntToStr(Page));
end;

procedure TForm1.PrintPreview1ChkAbort(Page:  Word);
begin
  Desc.Caption := 'Page: ' + IntToStr(Page);
end;

procedure TForm1.PrintPreview1SelectionPages(Sender: TObject);
begin
  PrintPreview1.FromPage := 12;
  PrintPreview1.ToPage := 36;
end;

procedure TForm1.PrintPreview1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  MousePosScreen: TPoint;
  MousePosHiMet: TPoint;
begin
  MousePosScreen := Point(X, Y);
  MousePosHiMet := PrintPreview1.MouseToHiMet(MousePosScreen);
  SendMessage(PrintPreview1.Handle, WM_SETREDRAW, 0, 0);
  with PrintPreview1 do
  begin
    if CurZoom = 2.0 then
      CurZoom := 4.0
    else if CurZoom = 1.0 then
      CurZoom := 2.0
    else
      CurZoom := 1.0;
  end;
  PrintPreview1.ZoomPos := MousePosHiMet;
  SendMessage(PrintPreview1.Handle, WM_SETREDRAW, 1, 0);
  PrintPreview1.Invalidate;
end;

procedure TForm1.PrintPreview1PageStart(Page: Word);
begin
  if Page mod 2 = 0 then
    PrintPreview1.Orientation := poLandscape
  else
    PrintPreview1.Orientation := poPortrait;

{  if ((Page div 3) mod 2) = 0 then
    PrintPreview1.PaperSize := DMPAPER_LETTER
  else
    PrintPreview1.PaperSize := DMPAPER_A4;}
end;

end.
